#ifndef OVAL_AGENT_API_H_
#define OVAL_AGENT_API_H_
#include <liboval/oval_definitions.h>
#include <liboval/oval_system_characteristics.h>
#include <liboval/oval_results.h>

	typedef void* Export_target;
	typedef void* Import_source;

	typedef void* Oval_object_model;

	Oval_object_model new_oval_object_model();

	Oval_object_model load_oval_definitions(Import_source source);

	Oval_definition get_oval_definition(Oval_object_model model, char* def_urn, int def_version);
	Oval_test       get_oval_test      (Oval_object_model model, char* tst_urn, int tst_version);
	Oval_object     get_oval_object    (Oval_object_model model, char* obj_urn, int obj_version);
	Oval_state      get_oval_state     (Oval_object_model model, char* ste_urn, int ste_version);
	Oval_variable   get_oval_variable  (Oval_object_model model, char* var_urn, int var_version);

	OvalCollection_definition get_oval_definitions(Oval_object_model model);
	OvalCollection_test       get_oval_tests      (Oval_object_model model);
	OvalCollection_object     get_oval_objects    (Oval_object_model model);
	OvalCollection_state      get_oval_states     (Oval_object_model model);
	OvalCollection_variable   get_oval_variables  (Oval_object_model model);

	/* needs Oval_characteristics, Export_target struct definitions */
	int export_characteristics(OvalCollection_syschar o_system_characteristics, Export_target target);

	/* needs Oval_results, Export_target struct definitions */
	int export_results(Oval_result o_results, Export_target target);

	OvalCollection_syschar probe_object(Oval_object o_object, OvalCollection_variableBinding o_var_bindings);
	Oval_resultTest resolve_test(Oval_test o_test, OvalCollection_syschar o_collected_objects, OvalCollection_variableBinding o_var_bindings);
	Oval_result resolve_definition(Oval_definition o_definition,  OvalCollection_syschar o_collected_objects, OvalCollection_variableBinding o_var_bindings);

#endif /* OVAL_AGENT_API_H_ */
