#ifndef OVAL_DEFINITIONS
#define OVAL_DEFINITIONS

	typedef enum{
		FAMILY_AIX         = 1000,
		FAMILY_APACHE      = 2000,
		FAMILY_CATOS       = 3000,
		FAMILY_ESX         = 4000,
		FAMILY_FREEBSD     = 5000,
		FAMILY_HPUX        = 6000,
		FAMILY_INDEPENDENT = 7000,
		FAMILY_IOS         = 8000,
		FAMILY_LINUX       = 9000,
		FAMILY_MACOS       = 10000,
		FAMILY_PIXOS       = 11000,
		FAMILY_SOLARIS     = 12000,
		FAMILY_UNIX        = 13000,
		FAMILY_WINDOWS     = 14000
	} Oval_family_enum;

	typedef enum{
		OVAL_SUBTYPE_UNKNOWN = 0
	} Oval_subtype_enum;

	typedef enum {
		AIX_FILESET = FAMILY_AIX+1,
		AIX_FIX     = FAMILY_AIX+2,
		AIX_OSLEVEL = FAMILY_AIX+3
	}Oval_aix_subtype_enum;

	typedef enum {
		APACHE_HTTPD   = FAMILY_APACHE+1,
		APACHE_VERSION = FAMILY_APACHE+2
	}Oval_apache_subtype_enum;

	typedef enum{
		CATOS_LINE       = FAMILY_CATOS+1,
		CATOS_MODULE     = FAMILY_CATOS+2,
		CATOS_VERSION_55 = FAMILY_CATOS+3,
		CATOS_VERSION    = FAMILY_CATOS+4
	} Oval_catos_subtype_enum;

	typedef enum {
		ESX_PATCH   = FAMILY_ESX+1,
		ESX_VERSION = FAMILY_ESX+2
	} Oval_esx_subtype_enum;

	typedef enum{
		FREEBSD_PORT_INFO = FAMILY_FREEBSD+1
	}Oval_freebsd_subtype_enum;

	typedef enum {
		HPUX_GETCONF          = FAMILY_HPUX+1,
		HPUX_PATCH_53         = FAMILY_HPUX+2,
		HPUX_PATCH            = FAMILY_HPUX+3,
		HPUX_SOFTWARE_LIST    = FAMILY_HPUX+4,
		HPUX_TRUSTED_ACCOUNTS = FAMILY_HPUX+5
	} Oval_hpux_subtype_enum;

	typedef enum{
		INDEPENDENT_FAMILY               = FAMILY_INDEPENDENT+1,
		INDEPENDENT_FILE_MD5             = FAMILY_INDEPENDENT+2,
		INDEPENDENT_FILE_HASH            = FAMILY_INDEPENDENT+3,
		INDEPENDENT_ENVIRONMENT_VARIABLE = FAMILY_INDEPENDENT+4,
		INDEPENDENT_SQL                  = FAMILY_INDEPENDENT+5,
		INDEPENDENT_TEXT_FILE_CONTENT    = FAMILY_INDEPENDENT+6,
		INDEPENDENT_UNKNOWN              = FAMILY_INDEPENDENT+7,
		INDEPENDENT_VARIABLE             = FAMILY_INDEPENDENT+8,
		INDEPENDENT_XML_FILE_CONTENT     = FAMILY_INDEPENDENT+9
	} Oval_independent_subtype_enum;

	typedef enum {
		IOS_GLOBAL     = FAMILY_IOS+1,
		IOS_INTERFACE  = FAMILY_IOS+2,
		IOS_LINE       = FAMILY_IOS+3,
		IOS_SNMP       = FAMILY_IOS+4,
		IOS_TCLSH      = FAMILY_IOS+5,
		IOS_VERSION_55 = FAMILY_IOS+6
	} Oval_ios_subtype_enum;

	typedef enum {
		LINUX_DPKG_INFO               = FAMILY_LINUX+1,
		LINUX_INET_LISTENING_SERVERS  = FAMILY_LINUX+2,
		LINUX_RPM_INFO                = FAMILY_LINUX+3,
		LINUX_SLACKWARE_PKG_INFO_TEST = FAMILY_LINUX+4
	} Oval_linux_subtype_enum;

	typedef enum {
		MACOS_ACCOUNT_INFO           = FAMILY_MACOS+1,
		MACOS_INET_LISTENING_SERVERS = FAMILY_MACOS+2,
		MACOS_NVRAM_INFO             = FAMILY_MACOS+3,
		MACOS_PWPOLICY               = FAMILY_MACOS+4
	}Oval_macos_subtype_enum;

	typedef enum {
		PIXOS_LINE    = FAMILY_PIXOS+1,
		PIXOS_VERSION = FAMILY_PIXOS+2
	}Oval_pixos_subtype_enum;

	typedef enum{
		SOLARIS_ISAINFO = FAMILY_SOLARIS+1,
		SOLARIS_PACKAGE = FAMILY_SOLARIS+2,
		SOLARIS_PATCH   = FAMILY_SOLARIS+3,
		SOLARIS_SMF     = FAMILY_SOLARIS+4
	}Oval_solaris_subtype_enum;

	typedef enum{
		UNIX_FILE      = FAMILY_UNIX+1,
		UNIX_INETD     = FAMILY_UNIX+2,
		UNIX_INTERFACE = FAMILY_UNIX+3,
		UNIX_PASSWORD  = FAMILY_UNIX+4,
		UNIX_PROCESS   = FAMILY_UNIX+5,
		UNIX_RUNLEVEL  = FAMILY_UNIX+6,
		UNIX_SCCS      = FAMILY_UNIX+7,
		UNIX_SHADOW    = FAMILY_UNIX+8,
		UNIX_UNAME     = FAMILY_UNIX+9,
		UNIX_XINETD    = FAMILY_UNIX+10
	}Oval_unix_subtype_enum;

	typedef enum{
		WINDOWS_ACCESS_TOKEN                  = FAMILY_WINDOWS+1,
		WINDOWS_ACTIVE_DIRECTORY              = FAMILY_WINDOWS+2,
		WINDOWS_AUDIT_EVENT_POLICY            = FAMILY_WINDOWS+3,
		WINDOWS_AUDIT_EVENT_SUBCATEGORIES     = FAMILY_WINDOWS+4,
		WINDOWS_FILE                          = FAMILY_WINDOWS+5,
		WINDOWS_FILE_AUDITED_PERMISSIONS_53   = FAMILY_WINDOWS+6,
		WINDOWS_FILE_AUDITED_PERMISSIONS      = FAMILY_WINDOWS+7,
		WINDOWS_FILE_EFFECTIVE_RIGHTS_53      = FAMILY_WINDOWS+8,
		WINDOWS_FILE_EFFECTIVE_RIGHTS         = FAMILY_WINDOWS+9,
		WINDOWS_GROUP                         = FAMILY_WINDOWS+10,
		WINDOWS_GROUP_SID                     = FAMILY_WINDOWS+11,
		WINDOWS_INTERFACE                     = FAMILY_WINDOWS+12,
		WINDOWS_LOCKOUT_POLICY                = FAMILY_WINDOWS+13,
		WINDOWS_METABASE                      = FAMILY_WINDOWS+14,
		WINDOWS_PASSWORD_POLICY               = FAMILY_WINDOWS+15,
		WINDOWS_PORT                          = FAMILY_WINDOWS+16,
		WINDOWS_PRINTER_EFFECTIVE_RIGHTS      = FAMILY_WINDOWS+17,
		WINDOWS_PROCESS                       = FAMILY_WINDOWS+18,
		WINDOWS_REGISTRY                      = FAMILY_WINDOWS+19,
		WINDOWS_REGKEY_AUDITED_PERMISSIONS_53 = FAMILY_WINDOWS+20,
		WINDOWS_REGKEY_AUDITED_PERMISSIONS    = FAMILY_WINDOWS+21,
		WINDOWS_REGKEY_EFFECTIVE_RIGHTS_53    = FAMILY_WINDOWS+22,
		WINDOWS_REGKEY_EFFECTIVE_RIGHTS       = FAMILY_WINDOWS+23,
		WINDOWS_SHARED_RESOURCE               = FAMILY_WINDOWS+24,
		WINDOWS_SID                           = FAMILY_WINDOWS+25,
		WINDOWS_SID_SID                       = FAMILY_WINDOWS+26,
		WINDOWS_USER_ACCESS_CONTROL           = FAMILY_WINDOWS+27,
		WINDOWS_USER                          = FAMILY_WINDOWS+28,
		WINDOWS_USER_SID_55                   = FAMILY_WINDOWS+29,
		WINDOWS_USER_SID                      = FAMILY_WINDOWS+30,
		WINDOWS_VOLUME                        = FAMILY_WINDOWS+31,
		WINDOWS_WMI                           = FAMILY_WINDOWS+32,
		WINDOWS_WUA_UPDATE_SEARCHER           = FAMILY_WINDOWS+33
	}Oval_windows_subtype_enum;

	typedef enum {
		AFCFML_CATOS,
		AFCFML_IOS,
		AFCFML_MACOS,
		AFCFML_PIXOS,
		AFCFML_UNDEFINED,
		AFCFML_UNIX,
		AFCFML_WINDOWS
	} Oval_affected_family_enum;

	typedef enum {
		NODETYPE_CRITERIA,
		NODETYPE_CRITERION,
		NODETYPE_EXTENDDEF
	} Oval_criteriaNode_type_enum;

	typedef enum {
		OPERATOR_UNKNOWN,
		OPERATOR_AND,
		OPERATOR_ONE,
		OPERATOR_OR,
		OPERATOR_XOR
	} Oval_operator_enum;

	typedef enum {
		CLASS_COMPLIANCE,
		CLASS_INVENTORY,
		CLASS_MISCELLANEOUS,
		CLASS_PATCH,
		CLASS_VULNERABILITY
	} Oval_definition_class_enum;

	typedef enum {
		ALL_EXIST,
		ANY_EXIST,
		AT_LEAST_ONE_EXISTS,
		ONLY_ONE_EXISTS
	} Oval_existence_enum;

	typedef enum {
		OVAL_CHECK_UNKNOWN,
		OVAL_CHECK_ALL,
		OVAL_CHECK_AT_LEAST_ONE,
		OVAL_CHECK_NONE_EXIST,
		OVAL_CHECK_NONE_SATISFY,
		OVAL_CHECK_ONLY_ONE
	} Oval_check_enum;

	typedef enum{
		OVAL_OBJECTCONTENT_ENTITY,
		OVAL_OBJECTCONTENT_SET
	} Oval_objectContent_type_enum;

	typedef enum{
		OVAL_ENTITY_TYPE_ANY,
		OVAL_ENTITY_TYPE_BINARY,
		OVAL_ENTITY_TYPE_BOOLEAN,
		OVAL_ENTITY_TYPE_FLOAT,
		OVAL_ENTITY_TYPE_INTEGER,
		OVAL_ENTITY_TYPE_STRING,
	}Oval_entity_type_enum;

	typedef enum{
		OVAL_DATATYPE_BINARY,
		OVAL_DATATYPE_BOOLEAN,
		OVAL_DATATYPE_EVR_STRING,
		OVAL_DATATYPE_FILESET_REVISTION,
		OVAL_DATATYPE_FLOAT,
		OVAL_DATATYPE_IOS_VERSION,
		OVAL_DATATYPE_VERSION,
		OVAL_DATATYPE_INTEGER,
		OVAL_DATATYPE_STRING
	}Oval_datatype_enum;;

	typedef enum{
		OVAL_ENTITY_VARREF_NONE,
		OVAL_ENTITY_VARREF_ATTRIBUTE,
		OVAL_ENTITY_VARREF_ELEMENT
	} Oval_entity_varref_type_enum;

	typedef enum{
		OVAL_SET_AGGREGATE,
		OVAL_SET_COLLECTIVE
	}Oval_set_type_enum;

	typedef enum{
		OVAL_SET_OPERATION_COMPLEMENT,
		OVAL_SET_OPERATION_INTERSECTION,
		OVAL_SET_OPERATION_UNION
	}Oval_set_operation_enum;

	typedef enum{
		OVAL_VARIABLE_EXTERNAL,
		OVAL_VARIABLE_CONSTANT,
		OVAL_VARIABLE_LOCAL
	}Oval_variable_type_enum;

	typedef enum{
		OVAL_COMPONENT_LITERAL,
		OVAL_COMPONENT_OBJECTREF,
		OVAL_COMPONENT_VARREF,
		OVAL_COMPONENT_FUNCTION
	}Oval_component_type_enum;

	typedef enum{
		OVAL_FUNCTION_UNKNOWN,
		OVAL_FUNCTION_BEGIN,
		OVAL_FUNCTION_CONCAT,
		OVAL_FUNCTION_END,
		OVAL_FUNCTION_SPLIT,
		OVAL_FUNCTION_SUBSTRING,
		OVAL_FUNCTION_TIMEDIF,
		OVAL_FUNCTION_ESCAPE_REGEX,
		OVAL_FUNCTION_REGEX_CAPTURE,
		OVAL_FUNCTION_ARITHMATIC
	}Oval_function_type_enum;

	typedef void* OvalCollection_string;

	typedef void* Oval_affected;
	typedef void* OvalCollection_affected;

	typedef void* Oval_test;
	typedef void* OvalCollection_test;

	typedef void* Oval_criteriaNode;
	typedef void* OvalCollection_criteriaNode;

	typedef void* Oval_reference;
	typedef void* OvalCollection_reference;

	typedef void* Oval_definition;
	typedef void* OvalCollection_definition;

	typedef void* Oval_object;
	typedef void* OvalCollection_object;

	typedef void* Oval_state;
	typedef void* OvalCollection_state;

	typedef void* Oval_variable;
	typedef void* OvalCollection_variable;

	typedef void* Oval_variableBinding;
	typedef void* OvalCollection_variableBinding;

	typedef void* Oval_objectContent;
	typedef void* OvalCollection_objectContent;

	typedef void* Oval_behavior;
	typedef void* OvalCollection_behavior;

	typedef void* Oval_entity;
	typedef void* OvalCollection_entity;

	typedef void* OvalCollection_set;
	typedef void* Oval_set;

	typedef void* Oval_value;
	typedef void* OvalCollection_value;

	typedef void* Oval_component;
	typedef void* OvalCollection_component;

	int   OvalCollection_string_hasMore      (OvalCollection_string);
	char* OvalCollection_string_next         (OvalCollection_string);

	int  OvalCollection_affected_hasMore      (OvalCollection_affected);
	Oval_affected OvalCollection_affected_next(OvalCollection_affected);

	int  OvalCollection_test_hasMore      (OvalCollection_test);
	Oval_test OvalCollection_test_next    (OvalCollection_test);

	Oval_affected_family_enum Oval_affected_family  (Oval_affected);
	OvalCollection_string     Oval_affected_platform(Oval_affected);
	OvalCollection_string     Oval_affected_product (Oval_affected);

	int  OvalCollection_criteriaNode_hasMore          (OvalCollection_criteriaNode);
	Oval_criteriaNode OvalCollection_criteriaNode_next(OvalCollection_criteriaNode);

	Oval_criteriaNode_type_enum Oval_criteriaNode_type      (Oval_criteriaNode);
	int                         Oval_criteriaNode_negate    (Oval_criteriaNode);
	char*                       Oval_criteriaNode_comment   (Oval_criteriaNode);
	Oval_operator_enum          Oval_criteriaNode_operator  (Oval_criteriaNode);//type==NODETYPE_CRITERIA
	OvalCollection_criteriaNode Oval_criteriaNode_subnodes  (Oval_criteriaNode);//type==NODETYPE_CRITERIA
	Oval_test                   Oval_criteriaNode_test      (Oval_criteriaNode);//type==NODETYPE_CRITERION
	Oval_definition             Oval_criteriaNode_definition(Oval_criteriaNode);//type==NODETYPE_EXTENDDEF

	int  OvalCollection_reference_hasMore          (OvalCollection_reference);
	Oval_reference OvalCollection_reference_next   (OvalCollection_reference);

	char* Oval_reference_source(Oval_reference);
	char* Oval_reference_id    (Oval_reference);
	char* Oval_reference_url   (Oval_reference);

	int  OvalCollection_definition_hasMore          (OvalCollection_definition);
	Oval_definition OvalCollection_definition_next  (OvalCollection_definition);

	char* Oval_definition_id                          (Oval_definition);
	int Oval_definition_version                       (Oval_definition);
	Oval_definition_class_enum Oval_definition_class  (Oval_definition);
	int Oval_definition_deprecated                    (Oval_definition);
	char* Oval_definition_title                       (Oval_definition);
	char* Oval_definition_description                 (Oval_definition);
	OvalCollection_affected Oval_definition_affected  (Oval_definition);
	OvalCollection_reference Oval_definition_reference(Oval_definition);
	Oval_criteriaNode Oval_definition_criteria        (Oval_definition);

	int  OvalCollection_object_hasMore      (OvalCollection_object);
	Oval_object OvalCollection_object_next  (OvalCollection_object);

	Oval_family_enum Oval_object_family                   (Oval_object);
	Oval_subtype_enum Oval_object_subtype                 (Oval_object);
	char* Oval_object_name                                (Oval_object);
	OvalCollection_string Oval_object_notes               (Oval_object);
	char* Oval_object_comment                             (Oval_object);
	char* Oval_object_id                                  (Oval_object);
	int Oval_object_deprecated                            (Oval_object);
	int Oval_object_version                               (Oval_object);
	OvalCollection_objectContent Oval_object_objectContent(Oval_object);
	OvalCollection_behavior Oval_object_behaviors         (Oval_object);

	int  OvalCollection_test_hasMore      (OvalCollection_test);
	Oval_test OvalCollection_test_next    (OvalCollection_test);

	Oval_family_enum Oval_test_family      (Oval_test);
	Oval_subtype_enum Oval_test_subtype    (Oval_test);
	char* Oval_test_name                   (Oval_test);
	OvalCollection_string Oval_test_notes  (Oval_test);
	char* Oval_test_comment                (Oval_test);
	char* Oval_test_id                     (Oval_test);
	int Oval_test_deprecated               (Oval_test);
	int Oval_test_version                  (Oval_test);
	Oval_operator_enum Oval_test_operator  (Oval_test);
	Oval_existence_enum Oval_test_existence(Oval_test);
	Oval_check_enum Oval_test_check        (Oval_test);
	Oval_object Oval_test_object           (Oval_test);
	Oval_state Oval_test_state             (Oval_test);

	int  OvalCollection_variableBinding_hasMore              (OvalCollection_variableBinding);
	Oval_variableBinding OvalCollection_variableBinding_next (OvalCollection_variableBinding);

	Oval_variable Oval_variableBinding_variable (Oval_variableBinding);
	char* Oval_variableBinding_value            (Oval_variableBinding);

	int  OvalCollection_objectContent_hasMore             (OvalCollection_objectContent);
	Oval_objectContent OvalCollection_objectContent_next  (OvalCollection_objectContent);

	char* Oval_objectContent_fieldName                  (Oval_objectContent);
	Oval_objectContent_type_enum Oval_objectContent_type(Oval_objectContent);
	Oval_entity Oval_objectContent_entity               (Oval_objectContent);//type == OVAL_OBJECTCONTENT_ENTITY
	Oval_check_enum Oval_objectContent_varCheck         (Oval_objectContent);//type == OVAL_OBJECTCONTENT_ENTITY
	Oval_set Oval_objectContent_set                     (Oval_objectContent);//type == OVAL_OBJECTCONTENT_SET

	int  OvalCollection_entity_hasMore      (OvalCollection_entity);
	Oval_entity OvalCollection_entity_next  (OvalCollection_entity);

	Oval_entity_type_enum Oval_entity_type              (Oval_entity);
	Oval_datatype_enum Oval_entity_datatype             (Oval_entity);
	Oval_operator_enum Oval_entity_operator             (Oval_entity);
	int Oval_entity_mask                                (Oval_entity);
	Oval_entity_varref_type_enum Oval_entity_varref_type(Oval_entity);
	Oval_variable Oval_entity_variable                  (Oval_entity);
	Oval_value Oval_entity_value                        (Oval_entity);

	int  OvalCollection_set_hasMore   (OvalCollection_set);
	Oval_set OvalCollection_set_next  (OvalCollection_set);

	Oval_set_type_enum Oval_set_type          (Oval_set);
	Oval_set_operation_enum Oval_set_operation(Oval_set);
	OvalCollection_set Oval_set_subsets       (Oval_set);//type==OVAL_SET_AGGREGATE;
	OvalCollection_object Oval_set_objects    (Oval_set);//type==OVAL_SET_COLLECTIVE;
	OvalCollection_state Oval_set_filters     (Oval_set);//type==OVAL_SET_COLLECTIVE;

	int  OvalCollection_behavior_hasMore        (OvalCollection_behavior);
	Oval_behavior OvalCollection_behavior_next  (OvalCollection_behavior);

	Oval_value Oval_behavior_value (Oval_behavior);
	OvalCollection_string Oval_behavior_attributeKeys (Oval_behavior);
	Oval_value Oval_behavior_value_forKey(Oval_behavior, char* attributeKey);

	int  OvalCollection_value_hasMore   (OvalCollection_value);
	Oval_value OvalCollection_value_next(OvalCollection_value);

	Oval_datatype_enum Oval_value_datatype(Oval_value);
	char* Oval_value_text                 (Oval_value);
	unsigned char* Oval_value_binary      (Oval_value);//datatype==OVAL_DATATYPE_BINARY
	char Oval_value_boolean               (Oval_value);//datatype==OVAL_DATATYPE_BOOLEAN
	float Oval_value_float                (Oval_value);//datatype==OVAL_DATATYPE_FLOAT
	long Oval_value_integer               (Oval_value);//datatype==OVAL_DATATYPE_INTEGER


	int  OvalCollection_state_hasMore      (OvalCollection_state);
	Oval_state OvalCollection_state_next   (OvalCollection_state);

	Oval_family_enum Oval_state_family    (Oval_state);
	Oval_subtype_enum Oval_state_subtype  (Oval_state);
	char* Oval_state_name                 (Oval_state);
	OvalCollection_string Oval_state_notes(Oval_state);
	char* Oval_state_comment              (Oval_state);
	char* Oval_state_id                   (Oval_state);
	int Oval_state_deprecated             (Oval_state);
	int Oval_state_version                (Oval_state);

	int  OvalCollection_variable_hasMore      (OvalCollection_variable);
	Oval_variable OvalCollection_variable_next(OvalCollection_variable);

	char* Oval_variable_Id                               (Oval_variable);
	Oval_variable_type_enum Oval_variable_type           (Oval_variable);
	Oval_datatype_enum Oval_variable_datatype            (Oval_variable);
	OvalCollection_value Oval_variable_values            (Oval_variable);//type==OVAL_VARIABLE_CONSTANT
	Oval_component Oval_variable_component               (Oval_variable);//type==OVAL_VARIABLE_LOCAL

	int  OvalCollection_component_hasMore       (OvalCollection_component);
	Oval_component OvalCollection_component_next(OvalCollection_component);

	Oval_component_type_enum Oval_component_type(Oval_component);
	Oval_value Oval_component_literalValue                     (Oval_component);//type==OVAL_COMPONENT_LITERAL
	Oval_object Oval_component_object                          (Oval_component);//type==OVAL_COMPONENT_OBJECTREF
	char* Oval_component_object_field                          (Oval_component);//type==OVAL_COMPONENT_OBJECTREF
	Oval_variable Oval_component_variable                      (Oval_component);//type==OVAL_COMPONENT_VARREF
	Oval_function_type_enum Oval_component_function_type       (Oval_component);//type==OVAL_COMPONENT_FUNCTION
	OvalCollection_component Oval_component_function_components(Oval_component);//type==OVAL_COMPONENT_FUNCTION
	OvalCollection_string Oval_component_function_keys         (Oval_component);           //type==OVAL_COMPONENT_FUNCTION
	Oval_value Oval_component_function_value                   (Oval_component, char* key);//type==OVAL_COMPONENT_FUNCTION

#endif
