#ifndef OVAL_RESULTS_H_
#define OVAL_RESULTS_H_
#include <liboval/oval_definitions.h>
#include <liboval/oval_system_characteristics.h>

	/*true, false, unknown, error, not evaluated, not applicable*/
	typedef enum{
		OVAL_RESULT_TRUE,
		OVAL_RESULT_FALSE,
		OVAL_RESULT_UNKNOWN,
		OVAL_RESULT_ERROR,
		OVAL_RESULT_NOT_EVALUATED,
		OVAL_RESULT_NOT_APPLICABLE
	} Oval_result_enum;

	typedef void* Oval_resultItem;
	typedef void* OvalCollection_resultItem;

	typedef void* Oval_resultTest;
	typedef void* OvalCollection_resultTest;

	typedef void* Oval_resultCriteriaNode;
	typedef void* OvalCollection_resultCriteriaNode;

	typedef void* Oval_resultDirectives;

	typedef void* Oval_result;
	typedef void* OvalCollection_result;

	int  OvalCollection_resultItem_hasMore         (OvalCollection_resultItem);
	Oval_resultItem OvalCollection_resultItem_next (OvalCollection_resultItem);

	Oval_sysData Oval_resultItem_sysData   (Oval_resultItem);
	Oval_result_enum Oval_resultItem_result(Oval_resultItem);
	char* Oval_resultItem_message          (Oval_resultItem);

	int  OvalCollection_resultTest_hasMore         (OvalCollection_resultTest);
	Oval_resultTest OvalCollection_resultTest_next (OvalCollection_resultTest);

	Oval_test Oval_resultTest_test                 (Oval_resultTest);
	Oval_check_enum Oval_resultTest_check          (Oval_resultTest);
	Oval_result_enum Oval_resultTest_result        (Oval_resultTest);
	char* Oval_resultTest_message                  (Oval_resultTest);
	OvalCollection_resultItem Oval_resultTest_items(Oval_resultTest);

	int  OvalCollection_resultCriteriaNode_hasMore                (OvalCollection_resultCriteriaNode);
	Oval_resultCriteriaNode OvalCollection_resultCriteriaNode_next(OvalCollection_resultCriteriaNode);

	Oval_criteriaNode_type_enum Oval_resultCriteriaNode_type    (Oval_resultCriteriaNode);
	Oval_result_enum Oval_resultCriteriaNode_result             (Oval_resultCriteriaNode);
	Oval_operator_enum Oval_resultCriteriaNode_operator         (Oval_resultCriteriaNode);//type==NODETYPE_CRITERIA
	OvalCollection_criteriaNode Oval_resultCriteriaNode_subnodes(Oval_resultCriteriaNode);//type==NODETYPE_CRITERIA
	Oval_resultTest Oval_resultCriteriaNode_test                (Oval_resultCriteriaNode);//type==NODETYPE_CRITERION
	Oval_result Oval_resultCriteriaNode_extends                 (Oval_resultCriteriaNode);//type==NODETYPE_EXTENDDEF

	int Oval_resultDirectives_definitionTrue         (Oval_resultDirectives);
	int Oval_resultDirectives_definitionFalse        (Oval_resultDirectives);
	int Oval_resultDirectives_definitionUnknown      (Oval_resultDirectives);
	int Oval_resultDirectives_definitionError        (Oval_resultDirectives);
	int Oval_resultDirectives_definitionNotEvaluated (Oval_resultDirectives);
	int Oval_resultDirectives_definitionNotApplicable(Oval_resultDirectives);

	int  OvalCollection_result_hasMore    (OvalCollection_result);
	Oval_result OvalCollection_result_next(OvalCollection_result);

	Oval_definition Oval_result_definition      (Oval_result);
	Oval_result_enum Oval_result_result         (Oval_result);
	char* Oval_result_message                   (Oval_result);
	Oval_resultDirectives Oval_result_directives(Oval_result);
	Oval_resultCriteriaNode Oval_result_criteria(Oval_result);

#endif /* OVAL_RESULTS_H_ */
