#ifndef OVAL_SYSTEM_CHARACTERISTICS
#define OVAL_SYSTEM_CHARACTERISTICS
#include "oval_definitions.h"

	typedef enum{
		SYSCHAR_FLAG_ERROR,
		SYSCHAR_FLAG_COMPLETE,
		SYSCHAR_FLAG_INCOMPLETE,
		SYSCHAR_FLAG_DOES_NOT_EXIST,
		SYSCHAR_FLAG_NOT_COLLECTED,
		SYSCHAR_FLAG_NOT_APPLICABLE
	} Oval_syscharCollectionFlag_enum;

	typedef void* Oval_sysInterface;
	typedef void* OvalCollection_sysInterface;

	typedef void* Oval_sysInfo;
	typedef void* OvalCollection_sysInfo;

	typedef void* Oval_sysData;
	typedef void* OvalCollection_sysData;

	typedef void* Oval_syschar;
	typedef void* OvalCollection_syschar;

	int  OvalCollection_sysInterface_hasMore            (OvalCollection_sysInterface);
	Oval_sysInterface OvalCollection_sysInterface_next  (OvalCollection_sysInterface);

	char* Oval_sysInterface_name      (Oval_sysInterface);
	char* Oval_sysInterface_ipAddress (Oval_sysInterface);
	char* Oval_sysInterface_macAddress(Oval_sysInterface);

	int  OvalCollection_sysInfo_hasMore       (OvalCollection_sysInfo);
	Oval_sysInfo OvalCollection_sysInfo_next  (OvalCollection_sysInfo);

	char* Oval_sysInfo_osName                          (Oval_sysInfo);
	char* Oval_sysInfo_osVersion                       (Oval_sysInfo);
	char* Oval_sysInfo_osArchitecture                  (Oval_sysInfo);
	char* Oval_sysInfo_primaryHostName                 (Oval_sysInfo);
	OvalCollection_sysInterface Oval_sysInfo_interfaces(Oval_sysInfo);

	int  OvalCollection_sysData_hasMore       (OvalCollection_sysData);
	Oval_sysData OvalCollection_sysData_next  (OvalCollection_sysData);

	Oval_family_enum Oval_sysData_family  (Oval_sysData);
	Oval_subtype_enum Oval_sysData_subtype(Oval_sysData);

	int  OvalCollection_syschar_hasMore       (OvalCollection_syschar);
	Oval_syschar OvalCollection_syschar_next  (OvalCollection_syschar);

	Oval_syscharCollectionFlag_enum Oval_syschar_flag           (Oval_syschar);
	OvalCollection_string Oval_syschar_messages                 (Oval_syschar);
	Oval_sysInfo Oval_syschar_sysInfo                           (Oval_syschar);
	Oval_object Oval_syschar_object                             (Oval_syschar);
	OvalCollection_variableBinding Oval_syschar_variableBindings(Oval_syschar);
	OvalCollection_sysData Oval_syschar_sysData                 (Oval_syschar);

#endif
